
#include <iostream.h>
#include <string.h>

class PUNKT{

	private:
	
	int x,y;

	public:
	PUNKT(int x, int y):x(x),y(y){

	}

	~PUNKT(){
	}

	void show(){
		cout <<  x << " " << y << endl;
	}

	friend PUNKT operator+ (const PUNKT &P1, const PUNKT &P2);
	friend PUNKT operator- (const PUNKT &P1, const PUNKT &P2);

	PUNKT operator* (const PUNKT &P1){
		return PUNKT(this->x*P1.x, this->y*P1.y);
	}
	PUNKT operator/ (const PUNKT &P1){
		return PUNKT(this->x/P1.x, this->y/P1.y);
	}
	PUNKT operator% (const PUNKT &P1){
		return PUNKT(this->x%P1.x, this->y%P1.y);
	}
	PUNKT operator- (){
		return PUNKT(-this->x, -this->y);
	}
};

PUNKT operator+ (const PUNKT &P1, const PUNKT &P2){
	return PUNKT(P1.x+P2.x, P1.y+P2.y);
}
PUNKT operator- (const PUNKT &P1, const PUNKT &P2){
	return PUNKT(P1.x-P2.x, P1.y-P2.y);
}


PUNKT	P1(10,11);
PUNKT	P2(12,13);
int main(){

	PUNKT P3=P1+P2;		// operator+ (P1, P2);
	P3.show();
	P3=P1-P2;
	P3.show();
	P3=P1*P2;			// P1.operator*(P2)
	P3.show();
	P3=P1/P2;
	P3.show();
	P3=P1%P2;
	P3.show();
	P3=-P1;
	P3.show();
	return 0;
}

