#include <iostream.h>

class Klasa {

public:

        int *val;                   // tablica liczb cakowitych

        int size;                   // dugo tablicy liczb cakowitych

 

        Klasa(int*args=0, int _size=0):size(_size) {    // konstruktor klasy

               val = 0;

               if(size>0) {

                       val = new int[size];

                       for(int i=0; i< size; i++)

                              val[i] = args[i];

               }

        }
// najmniejsza
		int operator~ (){
			if(this->size == 0)
				return NULL;
			int min = this->val[0];
			for (int i=1; i<this->size; i++)
			{
				if (this->val[i] < min)
					min = this->val[i];
			}
			return min;
		}
// najwieksza
		int operator! (){
			if(this->size == 0)
				return NULL;
			int maks = this->val[0];
			for(int i=1; i<this->size; i++)
				if(this->val[i] > maks)
					maks = this->val[i];
			return maks;
		}
// cout Klasa
		friend ostream& operator<<(ostream &wyjscie, const Klasa& klasa)
		{
			for(int i=0; i < klasa.size; i++)
				wyjscie << klasa.val[i];
			return wyjscie;

		}
// operator ==
		bool operator== (const Klasa &klasa){
			for(int i=0; i<this->size; i++)
			    if (val[i] != klasa.val[i])
					return false;
			return true;
		}
// operator !=
		bool operator!= (const Klasa &klasa){
			for(int i=0; i<this->size; i++)
				if(val[i] == klasa.val[i])
					return false;
			return true;
		}
// operator []
		int operator[] (int poz){
			return this->val[poz];
		}
// operator ,
		operator, (const Klasa &klasa){

			int suma0=0, suma1=0;
			for (int i=0; i<this->size; i++)
				suma0 += this->val[i];
			for (i=0; i<klasa.size; i++)
				suma1 += klasa.val[i];
			return suma0<suma1 ? suma0 : suma1;
		}
// konstruktor kopiujacy
		Klasa(const Klasa &klasa): val(klasa.val), size(klasa.size){

              val = new int[klasa.size];
			  size = klasa.size;
			  for(int i=0; i < this->size; i++)
			  {
				  val[i] = klasa.val[i];	  
			  }
		}
// operator =
		Klasa &operator= (const Klasa &klasa){
			val = new int[klasa.size];
			for (int i=0; i<klasa.size; i++)
				this->val[i] = klasa.val[i];
			return *this;

		}
// destruktor
		~Klasa(){

			delete[] val;
			val =0;
		}

};

 

 

int main() {

        int *tab1 = new int[10];

        for (int i=0; i<10; i++)      tab1[i] = i;                                               // inicjalizacja przykadowej tablicy 

        int *tab2 = new int[10];

        for (i=0; i<10; i++)      tab2[i] = i*10;                                          // inicjalizacja przykadowej tablicy

 

        Klasa k1(tab1, 10);

        Klasa k5(tab2, 10);

        Klasa *pk4  = new Klasa(tab2, 10);

 

        Klasa k2(k1);                                                                                // konstruktor kopiujcy

        

Klasa k3;  

k3 = k1;                                                                                       // operator przypisania

 

if(k3 == k1)                                                                                  // operator porwania ==

               cout << "Obiekty k3 i k1 sa rowne" << endl;

 

        if(k3 != *pk4)                                                                               // operator porwania !=

               cout << "Obiekty k3 i *pk4 sa rozne" << endl;

 

 

        cout << "Najwiksza liczba w obiekcie      = " << ! *pk4 << endl;             // operator !

        cout << "Najmniejsza liczba w obiekcie    = " << ~k1 << endl;                // operator ~

        cout << "Mniejsza suma liczb w obiektach k1 i k5 = " << (k1,k5) << endl;                // operator ,

        cout << "Liczba z pozycji 3                        = " << k1[2] << endl;              // operator [ ]

 

 

        cout << k1 << k2 << k3 << *pk4;            // operator <<
		cout << endl;

 

 
        delete pk4;                                             // destruktor

		

        delete tab1;

        delete tab2;

 

        return 0;

}                                                        

