#include<iostream.h>

class Klasa {
public:

        int *val;                   // tablica liczb cakowitych
        int size;                   // dugo tablicy liczb cakowitych
friend ostream& operator<<(ostream& , Klasa );
        Klasa(int*args=0, int _size=0):size(_size) {    // konstruktor klasy
			val = 0;
            if(size>0)
			{
				val = new int[size];
                for(int i=0; i< size; i++)

                              val[i] = args[i];
               }
        }
		
		Klasa(Klasa &k)
		{
				this->size = k.size;
				val = new int[size];
				for(int i =0 ; i <size ; i++)
				{
					val[i] = k.val[i];
				}
			
		}
		
		~Klasa()
		{
			delete[]val;
			val = 0;
		}

		const Klasa& operator=(const Klasa &tbl)
	   {
			if(size > 0)
				delete [] val;
			
			this->size = tbl.size ;
			this->val = new int[size];
			for(int i =0; i < size ; i++)
			{
				val[i] = tbl.val[i];
			}
			return *this;
	   }

		bool operator==(Klasa &k)
		{
			if(this->size != k.size)
				return false;
			for(int i = 0 ; i <k.size ; i++)
			{
				if(this->val[i] != k.val[i])
					return false;
			}
			return true;
		}
		
		bool operator!=(Klasa &k)
		{
			if(this->size != k.size)
				return true;
			for(int i = 0 ; i <k.size ; i++)
			{
				if(this->val[i] != k.val[i])
					return true;
			}
			return false;
		}
		int operator*()
		{
			int result;
			result = val[size/2];
			return result;
		}
		int operator,(Klasa &k)
		{
			if(this->val[size/2] > k.val[k.size/2]){
				return val[size/2];
			}else
				return k.val[k.size/2];
		}
		


};
ostream& operator<<(ostream& str, Klasa k)
{
	if(k.size > 0)
	{
		for(int i = 0 ; i < k.size ; i++)
			str<<k.val[i]<<" ";
		str<<" "<<endl;
		return str;
	}
	return str;
}

int main()
{

        int *tab1 = new int[10];
        for (int i=0; i<10; i++)   tab1[i] = i;                                               // inicjalizacja przykadowej tablicy 
        int *tab2 = new int[10];
        for (i=0; i<10; i++)      tab2[i] = i*10;                                          // inicjalizacja przykadowej tablicy

        Klasa k1(tab1, 10);
        Klasa k5(tab2, 10);
        Klasa *pk4  = new Klasa(tab2);
        Klasa k2(k1);                                                                                // konstruktor kopiujcy

Klasa k3;  

k3 = k1;                                                                                       // operator przypisania

if(k3 == k1)                                                                                  // operator porwania ==

               cout << "Obiekty k3 i k1 sa rowne" << endl;

 
        if(k3 != *pk4)                                                                               // operator porwania !=

               cout << "Obiekty k3 i *pk4 sa rozne" << endl;

cout << "Srodkowa liczba w k1 = " << *k1 << endl;                         // operator *

cout << "Srodkowa liczba w k5 = " << *k5 << endl;

    cout << "Dluzszy ze srodkowych lancuchow w obiektach k4 i k1 = " << (k1,k5) << endl;

 

    //    cout << "Liczba z pozycji 3                        = " << k1[2] << endl;              // operator [ ]

      cout << k1 << k2 << k3 << *pk4;            // operator <<
        delete pk4;                                             // destruktor
        delete tab1;
        delete tab2;

        return 0;
} 
